def merge_sort(ls):
    '''ordina la lista ls utilizzando l'algoritmo del merge-sort 
    ricorsivo'''
    if len(ls)>1:
        k=len(ls)//2
        #ordina le due meta' di ls
        ls1=ls[:k]
        merge_sort(ls1)
        ls2=ls[k:]
        merge_sort(ls2)
        #fondi i due insiemi ordinati nella lista originaria
        merge(ls,ls1,ls2)
    
def merge(ls,ls1,ls2):
    '''fonde due liste ordinate'''
    i,j,k=0,0,0
    while i<len(ls1) and j<len(ls2):
        if ls1[i]<=ls2[j]:
            ls[k]=ls1[i]
            i+=1
        else:
            ls[k]=ls2[j]
            j+=1
        k+=1
    while i<len(ls1):
        ls[k]=ls1[i]
        i+=1
        k+=1
    while j<len(ls2):
        ls[k]=ls2[j]
        j+=1
        k+=1

        
# >>> ls=[8,7,6,5,4,3,2,1] 
# >>> merge_sort(ls)
# >>> print(ls)        
# >>> [1, 2, 3, 4, 5, 6, 7, 8]  


# >>> ls=[1,8,3,6,5,4,7,2]
# >>> merge_sort(ls)
# >>> print(ls)        
# >>> [1, 2, 3, 4, 5, 6, 7, 8]  


#################################################################à


######################################################################

'''
(esame recupero di luglio)
Si definisca la funzione es2(n) che calcola la riga i-esima 
del triangolo di Tartaglia,
ovvero la lista dei coefficienti della potenza i-esima 
del binomio (a+b).

Si ricorda la definizione del triangolo di Tartaglia:
            1
           1 1
          1 2 1
         1 3 3 1
        1 4 6 4 1
       ...........

Tartaglia(0) = [1]   # caso base
I numeri che appaiono in ciascuna riga del triangolo di Tartaglia 
si ottengono come somma di quelli sovrastanti nella riga precedente.
Dove non troviamo una cifra consideriamo che si trovi un valore 
0 (zero)
'''
    
def es2(n):
    if n==0: return [1]
    lista1=es2(n-1)
    lista=[1]
    for i in range(len(lista1)-1):
        lista.append(lista1[i]+lista1[i+1])
    lista.append(1)
    return lista

# >>> es2(0)
# [1]
# >>> es2(1)
# [1, 1]
# >>> es2(2)
# [1, 2, 1]
# >>> es2(3)
# [1, 3, 3, 1]
# >>> es2(4)
# [1, 4, 6, 4, 1]


# alternativa:


def es2b(n):
    if n==0: return [1]
    t0 = [0] + es2b(n-1) + [0]
    return [ t0[i]+t0[i+1] for i in range(n+1) ]

######################################################################